#!/bin/bash

IFACE="$1"
CARRIER="/sys/class/net/${IFACE}/carrier"
LOCKDIR="/tmp/.network-carrier-${IFACE}"

# Check if carrier file exists
[ -f "${CARRIER}" ] || exit 1

# Remove lock directory
function cleanup {
	if ! rm -rf "${LOCKDIR}"; then
		echo >&2 "Unable to remove lockdir"
		exit 1
	fi
}

# Check if lock can be obtained
if mkdir -- "${LOCKDIR}"; then
	trap "cleanup" EXIT
else # Unable to get lock
	exit 0
fi

# Wait for carrier
while true ; do
	[ $(cat "/sys/class/net/${IFACE}/carrier") -eq 1 ] && {
		ifup ${IFACE}
		exit 0
	}

	sleep 3
done
